package com.fp.persistence.pgeneral.gene;

import javax.persistence.Column;
import java.io.Serializable;
import java.math.BigDecimal;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENEDENOMINATION*/
@Embeddable
public class TgeneDenominationKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="CURRENCYCODE", nullable=false,updatable=false)

/**
* Codigo de moneda
*/
private String currencycode;

@Column(name="CATALOG", nullable=false,updatable=false)

/**
* Codigo de catalogo  01 Natural, 02 Juridico
*/
private String catalog;

@Column(name="CATALOGCODE", nullable=false,updatable=false)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
private String catalogcode;

@Column(name="VALUE", nullable=false,updatable=false)

/**
* Valor de la denominacion
*/
private BigDecimal value;

/**Contructor por defecto*/
public TgeneDenominationKey(){}
/**Contructor de TgeneDenominationKey
@param pCurrencycode Codigo de moneda
@param pCatalog Codigo de catalogo  01 Natural, 02 Juridico
@param pCatalogcode Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
@param pValue Valor de la denominacion
*/
public TgeneDenominationKey(String pCurrencycode,String pCatalog,String pCatalogcode,BigDecimal pValue){
 currencycode=pCurrencycode;
 catalog=pCatalog;
 catalogcode=pCatalogcode;
 value=pValue;
}
/**Obtiene el valor de currencycode
@return valor de currencycode*/
public String getCurrencycode(){
  return currencycode;
}
/**Fija el valor de currencycode
@param pCurrencycode nuevo Valor de currencycode*/
public void setCurrencycode(String pCurrencycode){
  currencycode=pCurrencycode;
}

/**Obtiene el valor de catalog
@return valor de catalog*/
public String getCatalog(){
  return catalog;
}
/**Fija el valor de catalog
@param pCatalog nuevo Valor de catalog*/
public void setCatalog(String pCatalog){
  catalog=pCatalog;
}

/**Obtiene el valor de catalogcode
@return valor de catalogcode*/
public String getCatalogcode(){
  return catalogcode;
}
/**Fija el valor de catalogcode
@param pCatalogcode nuevo Valor de catalogcode*/
public void setCatalogcode(String pCatalogcode){
  catalogcode=pCatalogcode;
}

/**Obtiene el valor de value
@return valor de value*/
public BigDecimal getValue(){
  return value;
}
/**Fija el valor de value
@param pValue nuevo Valor de value*/
public void setValue(BigDecimal pValue){
  value=pValue;
}

/**Implementación de la comparación de TgeneDenominationKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneDenominationKey))return false;
  TgeneDenominationKey that = (TgeneDenominationKey) o;
  if (this.getCurrencycode() == null || that.getCurrencycode() == null){
      return false;
  }
  if (! this.getCurrencycode().equals(that.getCurrencycode())){
    return false;
  }
  if (this.getCatalog() == null || that.getCatalog() == null){
      return false;
  }
  if (! this.getCatalog().equals(that.getCatalog())){
    return false;
  }
  if (this.getCatalogcode() == null || that.getCatalogcode() == null){
      return false;
  }
  if (! this.getCatalogcode().equals(that.getCatalogcode())){
    return false;
  }
  if (this.getValue() == null || that.getValue() == null){
      return false;
  }
  if (! this.getValue().equals(that.getValue())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneDenominationKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCurrencycode() == null ? 0 : this.getCurrencycode().hashCode());
    result = result * 37 + (this.getCatalog() == null ? 0 : this.getCatalog().hashCode());
    result = result * 37 + (this.getCatalogcode() == null ? 0 : this.getCatalogcode().hashCode());
    result = result * 37 + (this.getValue() == null ? 0 : this.getValue().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
